;;; obsidian-config.el -*- lexical-binding: t; -*-

;; configure obsidian integration for note taking fun times
(use-package! obsidian
  :config
  (global-obsidian-mode t)
  ;;(obsidian-backlinks-mode t)
  :custom
  (obsidian-directory "~/documents/Obsidian/Primary/")
  (setq obsidian-inbox-directory "_Inbox")
  (markdown-enable-wiki-links t)
  (map! :map obsidian-mode-map
        "C-c C-o" #'obsidian-follow-link-at-point
        "C-c C-b" #'obsidian-backlink-jump
        "C-c C-l" #'obsidian-insert-wikilink)

  ;; custom quick capture template for obsidian daily note
  (defun mnl/obsidian-capture ()
    "Create new obsidian note. In the `obsidian-inbox-directory' if set otherwise in `obsidian-directory' root."
    (interactive)
    (let* ((title (read-from-minibuffer "Title: " (format-time-string "%Y-%m-%d")))
           (filename (s-concat obsidian-directory "_Journal/" title ".md"))
           (clean-filename (s-replace "//" "/" filename)))
      (find-file (expand-file-name clean-filename) t))))
